#import "AddressBook.h"

@implementation AddressBook;

// set up the AddressBook's name and an empty book



-(id) initWithName: (NSString *) name{
	self = [super init];

	if (self) {
		bookName = [[NSString alloc] initWithString: name];
		book = [[NSMutableArray alloc] init];
	}

	return self;
}

-(void) sort
{
	[book sortUsingSelector: @selector(compareNames:)];
}

-(void) addCard: (AddressCard *) theCard
{
	[book addObject: theCard];
}

-(void) removeCard: (AddressCard *) theCard
{
	[book removeObjectIdenticalTo: theCard];
}

-(int) entries
{
	return  [book count];
}

-(void) list
{
	int	     i, elements;
	AddressCard  *theCard;

	printf ("\n======== Contents of: %s =========\n",
        [bookName cString]);

	elements = [book count];

  	for ( i = 0; i < elements; ++i )  {
        	theCard = [book objectAtIndex: i];
        	printf ("%-20s    %-32s\n", [[theCard  name] cString],
                        [[theCard email] cString]);
	}

	printf("========================================\
============\n\n");
}

// lookup address card by name -- assumes an exact match

-(AddressCard *) lookup: (NSString *) theName
{
        AddressCard  *nextCard;

        int     i, elements;

	  elements = [book count];

        for ( i = 0; i < elements; ++i) {
                nextCard = [book  objectAtIndex: i];

                if ( [[nextCard name] caseInsensitiveCompare: theName]
	 	   == NSOrderedSame )
                        return nextCard;
        }

        return nil;
}

-(void) dealloc
{
	[bookName release];
	[book release];
	[super dealloc];
}

@end

