#import <Foundation/NSObject.h>
#import <Foundation/NSSet.h>
#import <Foundation/NSValue.h>
#import <Foundation/NSEnumerator.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSString.h>

// Create an integer object
#define INTOBJ(v)  [NSNumber  numberWithInt: v]

// Add a print method to NSSet with the Printing category
@interface  NSSet (Printing);
-(void) print;
@end

@implementation NSSet (Printing);
-(void) print {
	NSEnumerator  *setEnum;
	NSNumber      *element;

	setEnum = [self  objectEnumerator];

	printf (" {");

	while ((element  = [setEnum  nextObject]) != nil)
		printf (" %i ", [element intValue]);

	printf ("}\n");
}
@end


int main (int argc, char *argv[])
{
	NSAutoreleasePool    *pool = [[NSAutoreleasePool alloc] init];

	NSMutableSet  *set1 = [NSMutableSet setWithObjects:
		INTOBJ(1), INTOBJ(3), INTOBJ(5), INTOBJ(10), nil];
	NSSet  *set2 = [NSSet setWithObjects:
		INTOBJ(-5), INTOBJ(100), INTOBJ(3), INTOBJ(5), nil];
	NSSet  *set3 = [NSSet setWithObjects:
		INTOBJ(12), INTOBJ(200), INTOBJ(3), nil];

	printf ("set1: ");  [set1 print];
	printf ("set2: ");  [set2 print];
	
	// Equality test
	
	if ([set1 isEqualToSet: set2] == YES)
		printf ("set1 equals set2\n");
	else
		printf ("set1 is not equal to set2\n");
	
	// Membership test

	if ([set1 containsObject: INTOBJ(10)]  == YES)
		printf ("set1 contains 10\n");
	else
		printf ("set1 does not contain 10\n");

	if ([set2 containsObject: INTOBJ(10)]  == YES)
		printf ("set2 contains 10\n");
	else
		printf ("set2 does not contain 10\n");

	// add and remove objects from mutable set set1

	[set1 addObject: INTOBJ(4)];
	[set1 removeObject: INTOBJ(10)];
	printf ("set1 after adding 4 and removing 10: ");  [set1 print];

	// get intersection of two sets

	[set1 intersectSet: set2];
	printf ("set1 intersect set2: ");  [set1 print];

	// union of two sets

	[set1 unionSet:set3];
	printf ("set1 union set3: ");  [set1 print];

	[pool release];
	return 0;
}

