// Basic String Operations

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSAutoreleasePool.h>

int main (int argc, char *argv[])
{
	NSAutoreleasePool  *pool = [[NSAutoreleasePool alloc] init];
	NSString  *str1 = @"This is string A";
	NSString  *str2 = @"This is string B";
	NSString  *res;
	NSComparisonResult  compareResult;

	// Count the number of characters

	printf ("Length of str1: %i\n", [str1 length]);

	// Copy one string to another

	res = [NSString stringWithString: str1];
	printf ("Copy: %s\n", [res cString]);

	// Copy one string to the end of another

	str2 = [str1 stringByAppendingString: str2];
	printf ("Concatentation: %s\n", [str2 cString]);

	// Test if 2 strings are equal
	
	if ([str1 isEqualToString: res] == YES)
		printf ("str1 == res\n");
	else
		printf ("str1 != res\n");

	// Test if one string is <, == or > than another

	compareResult = [str1 compare: str2];

	if  (compareResult == NSOrderedAscending)
		printf ("str1 < str2\n");
	else if (compareResult == NSOrderedSame)
		printf ("str1 == str2\n");
	else  // NSOrderedDescending
		printf ("str1 > str2\n");

	// Convert a string to uppercase

	res = [str1 uppercaseString];
	printf ("Uppercase conversion: %s\n", [res cString]);

	// Convert a string to lowercase

	res = [str1 lowercaseString];
	printf ("Lowercase conversion: %s\n", [res cString]);

	printf ("Original string: %s\n", [str1 cString]);

	[pool release];
	return 0;
}
