// Basic String Operations - Continued

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSAutoreleasePool.h>

int main (int argc, char *argv[])
{
	NSAutoreleasePool  *pool = [[NSAutoreleasePool alloc] init];
	NSString  *str1 = @"This is string A";
	NSString  *str2 = @"This is string B";
	NSString  *res;
	NSRange   subRange;

	// Extract first 4 chars from string

	res = [str1 substringToIndex: 3];
	printf ("First 3 chars of str1: %s\n", [res cString]);

	// Extract chars to end of string starting at index 6

	res = [str1 substringFromIndex: 5];
	printf ("Chars from index 5 of str1: %s\n", [res cString]);

	// Extract chars from index 8 through 13 (6 chars)

	res = [[str1 substringFromIndex: 8] substringToIndex: 6];
	printf ("Chars from index 8 through 13: %s\n", [res cString]);

	// An easier way to do the same thing

	res = [str1 substringWithRange: NSMakeRange (8, 6)];
	printf ("Chars from index 8 through 13: %s\n", [res cString]);

	// Locate one string inside another

	subRange = [str1 rangeOfString: @"string A"];
	printf ("String is at index %i, length is %i\n", subRange.location, subRange.length);


	subRange = [str1 rangeOfString: @"string B"];

	if (subRange.location == NSNotFound)
		printf ("String not found\n");
	else
		printf ("String is at index %i, length is %i\n", 
			subRange.location, subRange.length);

	[pool release];
	return 0;
}
