#import <Foundation/NSObject.h>
#import <Foundation/NSArray.h>
#import <Foundation/NSString.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSValue.h>

#define MAXPRIME	50

int main (int argc, char *argv[])
{
	int	i, p, prevPrime;
	BOOL    isPrime;
	NSAutoreleasePool   *pool = [[NSAutoreleasePool alloc] init];

	// Create an array to store the prime numbers

	NSMutableArray  *primes = 
		[NSMutableArray arrayWithCapacity: 20];

	// Store the first two primes (2 and 3) into the array

	[primes  addObject: [NSNumber numberWithInt: 2]];
	[primes  addObject: [NSNumber numberWithInt: 3]];

	// Calculate the remaining primes

	for (p = 5; p <= MAXPRIME; p += 2) {
		// we're testing to see if p is prime

		isPrime = YES;

		i = 1;

		do {
			prevPrime = [[primes objectAtIndex: i] intValue];

			if (p % prevPrime == 0)
				isPrime = NO;

			++i;
		} while ( isPrime == YES && p / prevPrime >= prevPrime);

		if (isPrime) 
			[primes addObject: [NSNumber numberWithInt: p]];
	}
			

	// Display the results

	for (i = 0; i < [primes count]; ++i)
		printf ("%i  ", [[primes objectAtIndex: i] intValue]);

	printf ("\n");

	[pool release];
	return 0;
}
	

