// Some basic directory operations

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSFileManager.h>
#import <Foundation/NSAutoreleasePool.h>

int main (int argc, char *argv[])
{
	NSAutoreleasePool  *pool = [[NSAutoreleasePool alloc] init];
	NSString           *dirName = @"testdir";
	NSString           *path;
	NSFileManager      *NSFm;

	// Need to create an instance of the file manager

	NSFm = [NSFileManager  defaultManager];

	// Get current directory

	path = [NSFm currentDirectoryPath];
	NSLog (@"Current directory path is %@\n", path);
	
	// Create a new directory

	if ([NSFm createDirectoryAtPath: dirName
			       attributes: nil] == NO) {
		NSLog (@"Couldn't create directory!\n");
		return 1;
	}

	// Rename the new directory

	if ([NSFm movePath: dirName toPath: @"newdir" handler: nil] == NO) {
		NSLog (@"Directory rename failed!\n");
		return 2;
	}

	// Change directory into the new directory

	if ([NSFm changeCurrentDirectoryPath: @"newdir"] == NO) {
		NSLog (@"Change directory failed!\n");
		return 3;
	}

	// Now get and display current working directory

	path = [NSFm currentDirectoryPath];
	NSLog (@"Current directory path is %@\n", path);
	
	NSLog (@"All operations were successful!\n");

	[pool release];
	return 0;
}

