// Enumerate the contents of a directory

#import <Foundation/NSString.h>
#import <Foundation/NSFileManager.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSArray.h>

int main (int argc, char *argv[])
{
	NSAutoreleasePool     *pool = [[NSAutoreleasePool alloc] init];
	NSString              *path;
	NSFileManager         *NSFm;
	NSDirectoryEnumerator *dirEnum;
	NSArray		    *dirArray;
	int			    i, n;

	// Need to create an instance of the file manager

	NSFm = [NSFileManager  defaultManager];

	// Get current working directory path

	path = [NSFm currentDirectoryPath];
	
	// Enumerate the directory

 	dirEnum = [NSFm enumeratorAtPath: path];

	printf ("Contents of %s:\n", [path cString]);

	while ((path = [dirEnum nextObject]) != nil)
		printf ("%s\n", [path cString]);
	
	// Another way to enumerate a directory

	dirArray = [NSFm directoryContentsAtPath:
                             [NSFm currentDirectoryPath]];
	printf ("\nContents using directoryContentsAtPath:\n");

	n = [dirArray count];

	for (i = 0; i < n; ++i)
		printf ("%s\n", [[dirArray objectAtIndex: i] cString]);

	[pool release];
	return 0;
}

