// Some basic path operations

#import <Foundation/NSString.h>
#import <Foundation/NSArray.h>
#import <Foundation/NSFileManager.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSPathUtilities.h>

int main (int argc, char *argv[])
{
	NSAutoreleasePool  *pool = [[NSAutoreleasePool alloc] init];
	NSString           *fName = @"path.m";
	NSFileManager      *NSFm;
	NSString	   *path, *tempdir, *extension, *homedir, *fullpath;
	NSString           *upath = @"~stevekochan/progs/../ch16/./path.m";

	NSArray             *components;
	int	            i, n;

	NSFm = [NSFileManager  defaultManager];

	// Get the temporary working directory

	tempdir = NSTemporaryDirectory ();

	printf ("Temporary Directory is %s\n", [tempdir cString]);

	// Extract the base directory from current directory

	path = [NSFm currentDirectoryPath];
	printf ("Base dir is %s\n", [[path lastPathComponent] cString]);

	// Create a full path to the file fName in current directory

	fullpath = [path stringByAppendingPathComponent: fName];
	printf ("fullpath to %s is %s\n", [fName cString], [fullpath cString]);

	// Get the file name extension

	extension =  [fullpath pathExtension];
	printf ("extension for %s is %s\n", [fullpath cString],
			[extension cString]);

	// Get user's home directory

	homedir = NSHomeDirectory ();
	printf ("Your home directory is %s\n",  [homedir cString]);

	// Divide a path into its components

	components = [homedir pathComponents];

	n = [components count];

	for (i = 0; i < n; ++i)
		printf ("   %s\n", [[components objectAtIndex: i] cString]);

	// "Standardize" a path

	printf ("%s => %s\n", [upath cString],
                [[upath stringByStandardizingPath] cString]);
	
	[pool release];
	return 0;
}

