// Introduction to reference counting

#import <Foundation/NSObject.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSString.h>
#import <Foundation/NSArray.h>
#import <Foundation/NSValue.h>

int main (int argc, char *argv[])
{      
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    NSNumber          *myInt  = [NSNumber numberWithInt: 100];
    NSNumber          *myInt2;
    NSMutableArray    *myArr = [NSMutableArray array];

    printf ("myInt retain count = %x\n", [myInt retainCount]);

    [myArr addObject: myInt];
    printf ("after adding to array = %x\n", [myInt retainCount]);

    myInt2 = myInt;
    printf ("after asssignment to myInt2 = %x\n",
                                     [myInt retainCount]);

    [myInt retain];
    printf ("myInt after retain = %x\n", [myInt retainCount]);
    printf ("myInt2 after retain = %x\n", [myInt2 retainCount]);

    [myInt release];
    printf ("after release = %x\n", [myInt retainCount]);

    [myArr removeObjectAtIndex: 0];
    printf ("after removal from array = %x\n", [myInt retainCount]);

    [pool release];
    return 0;

}

