// Introduction to reference counting

#import <Foundation/NSObject.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSString.h>
#import <Foundation/NSArray.h>

@interface ClassA: NSObject
{
	NSString  *str;
}

-(void) setStr: (NSString *) s;
-(NSString *) str;
-(void) dealloc;
@end

@implementation ClassA;
-(void) setStr: (NSString *) s
{
	// free up old object since we're done with it
	[str  autorelease];

	// retain argument in case someone else releases it
	str = [s retain];
}

-(NSString *) str
{
	return str;
}
-(void) dealloc {
	printf ("Foo dealloc\n");

	[str release];
	[super dealloc];
}
@end

int main (int argc, char *argv[])
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	NSString	*myStr = [NSString  stringWithString: @"A string"];
	ClassA	*myA = [[ClassA  alloc] init];
	
	printf ("myStr retain count: %x\n", [myStr retainCount]);
	[myA autorelease];

	[myA setStr: myStr];
	printf ("myStr retain count: %x\n", [myStr  retainCount]);

	[pool release];
	return 0;
}

