#import "AddressCard.h"

@implementation AddressCard;

-(id) initWithName: (NSString *) theName andEmail: (NSString *) theEmail
{
	self = [super init];

	[self setName: theName andEmail: theEmail];
	return self;
}

-(void) setName: (NSString *) theName
{
	[name autorelease];
	name = [theName copy];
}

-(void) setEmail: (NSString *) theEmail
{
	[email autorelease];
	email = [theEmail copy];
}

-(void) setName: (NSString *) theName andEmail: (NSString *) theEmail
{
	[self setName: theName];
	[self setEmail: theEmail];
}

-(NSString *) name
{
	return name;
}

-(NSString *) email
{
	return email;
}

-(NSComparisonResult) compareNames: (id) element
{
	return [name compare: [element name]];
}

-(void) dealloc
{
   [name release];
   [email release];
   [super dealloc];
}

-(void) print
{
	printf ("====================================\n");
	printf ("|                                  |\n");
	printf ("| %-31s  |\n", [name cString]);
	printf ("| %-31s  |\n", [email cString]);
	printf ("|                                  |\n");
	printf ("|                                  |\n");
	printf ("|                                  |\n");
	printf ("|          O             O         |\n");
	printf ("====================================\n");
}

-(void) encodeWithCoder: (NSCoder *) encoder
{
	if ( [encoder allowsKeyedCoding] ) {
		[encoder encodeObject: name forKey: @"AddressBookname"];
		[encoder encodeObject: email forKey: @"AddressBookemail"];
	} else {
		[encoder encodeObject: name];
		[encoder encodeObject: email];
	}
}

-(id) initWithCoder: (NSCoder *) decoder
{
	if ( [decoder allowsKeyedCoding] ) {
		name = [[decoder decodeObjectForKey: @"AddressBookname"] retain];
		email = [[decoder decodeObjectForKey: @"AddressBookemail"] retain];
	} else {
		name = [[decoder decodeObject] retain];
		email = [[decoder decodeObject] retain];
	}

	return self;
}

-(AddressCard *) copyWithZone: (NSZone *) zone
{
 	AddressCard *newCard = [[AddressCard allocWithZone: zone] init];

 	[newCard retainName: name andEmail: email];


 	return newCard;
}

-(void) retainName: (NSString *) theName andEmail: (NSString *) theEmail
{
	name = [theName retain];
	email = [theEmail retain];
}
@end
