#import <Foundation/NSObject.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSString.h>
#import <Foundation/NSKeyedArchiver.h>
#import <Foundation/NSCoder.h>
#import <Foundation/NSData.h>
#import "AddressBook.h"


@interface Foo: NSObject <NSCoding>
{
    NSString *strVal;
    int       intVal;
    float    floatVal;
}

-(void) setAll: (NSString *) ss iVal: (int) ii fVal: (float) ff;

-(NSString *) strVal;
-(int) intVal;
-(float) floatVal;
@end

@implementation Foo;
-(void) setAll: (NSString *) ss iVal: (int) ii fVal: (float) ff
{
    strVal = ss;
    intVal = ii;
    floatVal = ff;
}

-(NSString *) strVal   { return strVal; }
-(int)        intVal   { return intVal; }
-(float)      floatVal { return floatVal; }


-(void) encodeWithCoder: (NSCoder *) encoder
{
   if ( [encoder allowsKeyedCoding] ) {
      [encoder encodeObject: strVal forKey: @"FoostrVal"];
      [encoder encodeInt: intVal forKey: @"FoointVal"];
      [encoder encodeFloat: floatVal forKey: @"FoofloatVal"];
   } else {
      [encoder encodeObject: strVal];
      [encoder encodeValueOfObjCType: @encode(int) at: &intVal];
      [encoder encodeValueOfObjCType: @encode(float) at: &floatVal];
   }
}

-(id) initWithCoder: (NSCoder *) decoder
{
   if ( [decoder allowsKeyedCoding] ) {
      strVal = [[decoder decodeObjectForKey: @"FoostrVal"] retain];
      intVal = [decoder decodeIntForKey: @"FoointVal"];
      floatVal = [decoder decodeFloatForKey: @"FoofloatVal"];
   } else {
      strVal = [[decoder decodeObject] retain];
      [decoder decodeValueOfObjCType: @encode(int) at: &intVal];
      [decoder decodeValueOfObjCType: @encode(float) at: &floatVal];
   }

    return self;
}
@end

int main (int argc, char *argv[])
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	NSData	          *dataArea;
	NSKeyedUnarchiver *unarchiver;
	Foo               *myFoo1;
	AddressBook       *myBook;

	// Read in the archive and connect an
	// NSKeyedUnarchiver object to it

	dataArea = [NSData dataWithContentsOfFile: @"myArchive"];
	unarchiver = [[NSKeyedUnarchiver alloc]
                          initForReadingWithData: dataArea];

	// Decode the objects we previously stored in the archive
	myBook = [unarchiver decodeObjectForKey: @"myaddrbook"];
	myFoo1  = [unarchiver decodeObjectForKey: @"myfoo1"];
	
	[unarchiver finishDecoding];

	[unarchiver release];
		
	// Verify that the restore was successful
	[myBook list];
  	printf ("%s\n%i\n%g\n", [[myFoo1 strVal] cString],
       	   [myFoo1 intVal], [myFoo1 floatVal]);

	[pool release];
	return 0;
}

