#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSArchiver.h>
#import <Foundation/NSAutoreleasePool.h>

@interface Foo: NSObject <NSCoding>
{
    NSString *strVal;
    int   	  intVal;
    float    floatVal;
}
-(void) setAll: (NSString *) ss iVal: (int) ii fVal: (float) ff;
-(NSString *) strVal;
-(int)        intVal;
-(float)      floatVal;
@end

@implementation Foo;

-(void) setAll: (NSString *) ss iVal: (int) ii fVal: (float) ff
{
    strVal = ss;
    intVal = ii;
    floatVal = ff;
}

-(NSString *) strVal   { return strVal; }
-(int)        intVal   { return intVal; }
-(float)      floatVal { return floatVal; }

-(void) encodeWithCoder: (NSCoder *) encoder
{
   [encoder encodeObject: strVal];
	[encoder encodeValueOfObjCType: @encode(int) 
                                    at: &intVal];	          
	[encoder encodeValueOfObjCType: @encode(float) 
                                    at: &floatVal];
}

-(id) initWithCoder: (NSCoder *) decoder
{
   strVal = [[decoder decodeObject] retain];
   [decoder decodeValueOfObjCType: @encode(int) at: &intVal];
   [decoder decodeValueOfObjCType: @encode(float) at: &floatVal];

   return self;
}
@end

int main (int argc, char *argv[])
{
   NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
   Foo *myFoo1 = [[Foo alloc] init];
   Foo *myFoo2;

   [myFoo1 setAll: @"This is the string" iVal: 12345 fVal: 98.6];
   [NSArchiver archiveRootObject: myFoo1 toFile: @"foo.arch"];

   myFoo2 = [NSUnarchiver unarchiveObjectWithFile: @"foo.arch"];
   printf ("%s\n%i\n%g\n", [[myFoo2 strVal] cString],
          [myFoo2 intVal], [myFoo2 floatVal]);
	[myFoo1 release];
   [pool release];
   return 0;
}

