#import <Foundation/NSObject.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSString.h>
#import <Foundation/NSKeyedArchiver.h>
#import <Foundation/NSCoder.h>

@interface Foo: NSObject <NSCoding>
{
    NSString *strVal;
    int       intVal;
    float    floatVal;
}

-(void) setAll: (NSString *) ss iVal: (int) ii fVal: (float) ff;

-(NSString *) strVal;
-(int) intVal;
-(float) floatVal;
@end

@implementation Foo;
-(void) setAll: (NSString *) ss iVal: (int) ii fVal: (float) ff
{
    strVal = ss;
    intVal = ii;
    floatVal = ff;
}

-(NSString *) strVal   { return strVal; }
-(int)        intVal   { return intVal; }
-(float)      floatVal { return floatVal; }


-(void) encodeWithCoder: (NSCoder *) encoder
{
   if ( [encoder allowsKeyedCoding] ) {
      [encoder encodeObject: strVal forKey: @"FoostrVal"];
      [encoder encodeInt: intVal forKey: @"FoointVal"];
      [encoder encodeFloat: floatVal forKey: @"FoofloatVal"];
   } else {
      [encoder encodeObject: strVal];
      [encoder encodeValueOfObjCType: @encode(int) at: &intVal];
      [encoder encodeValueOfObjCType: @encode(float) at: &floatVal];
   }
}

-(id) initWithCoder: (NSCoder *) decoder
{
   if ( [decoder allowsKeyedCoding] ) {
      strVal = [[decoder decodeObjectForKey: @"FoostrVal"] retain];
      intVal = [decoder decodeIntForKey: @"FoointVal"];
      floatVal = [decoder decodeFloatForKey: @"FoofloatVal"];
   } else {
      strVal = [[decoder decodeObject] retain];
      [decoder decodeValueOfObjCType: @encode(int) at: &intVal];
      [decoder decodeValueOfObjCType: @encode(float) at: &floatVal];
   }

    return self;
}
@end


int main (int argc, char *argv[])
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	Foo *myFoo1 = [[Foo alloc] init];
	Foo *myFoo2;
	
	// First set and archive myFoo1 to a file
	[myFoo1 setAll: @"This is the string" iVal: 12345 fVal: 98.6];
	[NSKeyedArchiver archiveRootObject: myFoo1 toFile: @"foo.karch"];

	// Now restore the archive into myFoo2
	myFoo2 = [NSKeyedUnarchiver unarchiveObjectWithFile: 
                                             @"foo.karch"];
	printf ("%s\n%i\n%g\n", [[myFoo2 strVal] cString],
             [myFoo2 intVal], [myFoo2 floatVal]);

	[myFoo1 release];	
	[pool release];
	return 0;
}

