#import <stdio.h>
#import <objc/Object.h>

@interface  Fraction: Object
{
	int	numerator;
	int	denominator;
}

-(void)   print;
-(void)   setNumerator: (int) n;
-(void)   setDenominator: (int) d;
-(int)    numerator;
-(int)    denominator;
-(double) convertToNum;
@end


@implementation Fraction;
-(void) print
{
	printf (" %i/%i ", numerator, denominator);
}

-(void) setNumerator: (int) n
{
	numerator = n;
}

-(void) setDenominator: (int) d
{
	denominator = d;
}

-(int) numerator
{
	return numerator;
}

-(int) denominator
{
	return denominator;
}

-(double) convertToNum
{
	if (denominator != 0)
		return (double) numerator / denominator;
	else
		return 0.0;
}
@end

int main (int argc, char *argv[])
{
	Fraction *aFraction = [[Fraction alloc] init];
	Fraction *bFraction = [[Fraction alloc] init];

 	[aFraction setNumerator: 1];   // 1st fraction is 1/4
	[aFraction setDenominator: 4];

 	[aFraction print];
	printf (" = ");
	printf ("%g\n", [aFraction convertToNum]);

	[bFraction print];	      // never assigned a value
	printf (" = ");
	printf ("%g\n", [bFraction convertToNum]);

	[aFraction free];
	[bFraction free];

	return 0;
}
